"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var node_assert_1 = __importDefault(require("node:assert"));
var globals_1 = require("@jest/globals");
var init_1 = __importDefault(require("./init"));
var node_path_1 = __importDefault(require("node:path"));
var node_fs_1 = __importDefault(require("node:fs"));
var colors_1 = __importDefault(require("colors"));
var yaml_1 = __importDefault(require("yaml"));
var test_utils_1 = require("../utils/test-utils");
var programMock = (0, test_utils_1.getProgramMock)();
(0, globals_1.describe)(colors_1.default.yellow('init'), function () {
    (0, globals_1.it)('OK - Should create Files - type=sql', function () {
        var dir = (0, test_utils_1.getTempFolder)();
        console.log(colors_1.default.green('Temp Folder: ' + dir));
        var options = {
            type: 'sql',
            name: 'TEST name',
            tags: 'test,cli',
            description: 'TEST_DESCRIPTION',
            chain: 'sui',
            logo: 'https://test.com/logo.png',
            subscribable: false,
        };
        init_1.default.init(programMock, dir, options);
        var files = node_fs_1.default.readdirSync(dir);
        node_assert_1.default.strictEqual(files.length, 5);
        node_assert_1.default.strictEqual(files.includes('readme.md'), true);
        node_assert_1.default.strictEqual(files.includes('package.json'), true);
        node_assert_1.default.strictEqual(files.includes('manifest.yml'), true);
        node_assert_1.default.strictEqual(files.includes('queries.yml'), true);
        var packageJson = node_fs_1.default.readFileSync(node_path_1.default.join(dir, 'package.json'), 'utf-8');
        var packageParsed = JSON.parse(packageJson);
        node_assert_1.default.deepEqual(packageParsed, {
            dependencies: { '@mamoru-ai/mamoru-sdk-as': '^0.2.1' },
            description: 'TEST_DESCRIPTION',
            devDependencies: { assemblyscript: '^0.27.1' },
            license: 'Apache-2.0',
            name: 'test-name',
            scripts: {
                build: 'asc src/index.ts --exportRuntime --outFile build/index.wasm -b build/index.wat --sourceMap --optimize --exportRuntime --runtime stub --lib',
            },
            tags: ['test', 'cli'],
            version: '0.0.1',
        });
        var manifest = node_fs_1.default.readFileSync(node_path_1.default.join(dir, 'manifest.yml'), 'utf-8');
        var manifestParsed = yaml_1.default.parse(manifest);
        node_assert_1.default.deepEqual(manifestParsed, {
            chain: 'sui',
            description: 'TEST_DESCRIPTION',
            logoUrl: 'https://test.com/logo.png',
            name: 'test-name',
            tags: ['test', 'cli'],
            version: '0.0.1',
            type: 'sql',
            subscribable: false,
        });
        var queries = node_fs_1.default.readFileSync(node_path_1.default.join(dir, 'queries.yml'), 'utf-8');
        var queriesParsed = yaml_1.default.parse(queries);
        node_assert_1.default.deepEqual(queriesParsed, {
            queries: [
                {
                    query: 'Select * from EXAMPLE',
                    incidentMessage: 'Incident: {{query.name}} - {{query.message}}',
                    severity: 'WARNING',
                },
            ],
        });
    });
    (0, globals_1.it)('OK - Should create Files - type=wasm', function () { return __awaiter(void 0, void 0, void 0, function () {
        var dir, options, files, srcFiles, testFiles, packageJson, parsedPackage, manifest, manifestParsed;
        return __generator(this, function (_a) {
            dir = (0, test_utils_1.getTempFolder)();
            options = {
                type: 'wasm',
                name: 'TEST name',
                tags: 'test,cli',
                description: 'TEST_DESCRIPTION',
                chain: 'sui',
                logo: 'https://test.com/logo.png',
                subscribable: false,
            };
            init_1.default.init(programMock, dir, options);
            files = node_fs_1.default.readdirSync(dir);
            node_assert_1.default.strictEqual(files.length, 6);
            node_assert_1.default.strictEqual(files.includes('readme.md'), true);
            node_assert_1.default.strictEqual(files.includes('package.json'), true);
            node_assert_1.default.strictEqual(files.includes('manifest.yml'), true);
            node_assert_1.default.strictEqual(files.includes('.gitignore'), true);
            node_assert_1.default.strictEqual(files.includes('src'), true);
            node_assert_1.default.strictEqual(files.includes('test'), true);
            srcFiles = node_fs_1.default.readdirSync(node_path_1.default.join(dir, 'src'));
            node_assert_1.default.strictEqual(srcFiles.length, 1);
            node_assert_1.default.strictEqual(srcFiles.includes('index.ts'), true);
            testFiles = node_fs_1.default.readdirSync(node_path_1.default.join(dir, 'test'));
            node_assert_1.default.strictEqual(testFiles.length, 1);
            node_assert_1.default.strictEqual(testFiles.includes('index.spec.ts'), true);
            packageJson = node_fs_1.default.readFileSync(node_path_1.default.join(dir, 'package.json'), 'utf-8');
            parsedPackage = JSON.parse(packageJson);
            node_assert_1.default.deepEqual(parsedPackage, {
                dependencies: { '@mamoru-ai/mamoru-sdk-as': '^0.2.1' },
                description: 'TEST_DESCRIPTION',
                devDependencies: { assemblyscript: '^0.27.1' },
                license: 'Apache-2.0',
                name: 'test-name',
                scripts: {
                    build: 'asc src/index.ts --exportRuntime --outFile build/index.wasm -b build/index.wat --sourceMap --optimize --exportRuntime --runtime stub --lib',
                },
                tags: ['test', 'cli'],
                version: '0.0.1',
            });
            manifest = node_fs_1.default.readFileSync(node_path_1.default.join(dir, 'manifest.yml'), 'utf-8');
            manifestParsed = yaml_1.default.parse(manifest);
            node_assert_1.default.deepEqual(manifestParsed, {
                chain: 'sui',
                description: 'TEST_DESCRIPTION',
                logoUrl: 'https://test.com/logo.png',
                name: 'test-name',
                tags: ['test', 'cli'],
                version: '0.0.1',
                type: 'wasm',
                subscribable: false,
            });
            return [2 /*return*/];
        });
    }); });
    (0, globals_1.it)('FAIL - Fail if project is already in folder', function () {
        var dir = (0, test_utils_1.getTempFolder)();
        // console.log(colors.green('Temp Folder: ' + dir))
        var options = {
            type: 'sql',
            name: 'TEST name',
            tags: 'test,cli',
            description: 'TEST_DESCRIPTION',
            chain: 'sui',
            logo: 'https://test.com/logo.png',
            subscribable: false,
        };
        init_1.default.init(programMock, dir, options);
        try {
            init_1.default.init(programMock, dir, options);
            throw new Error('Test should fail');
        }
        catch (error) {
            // pass
        }
    });
});
//# sourceMappingURL=init.test.js.map