"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var node_assert_1 = __importDefault(require("node:assert"));
var globals_1 = require("@jest/globals");
var publish_1 = __importDefault(require("./publish"));
var colors_1 = __importDefault(require("colors"));
var init_1 = __importDefault(require("./init"));
var build_1 = __importDefault(require("./build"));
var test_utils_1 = require("../utils/test-utils");
var utils_1 = require("../utils/utils");
var programMock = (0, test_utils_1.getProgramMock)();
(0, globals_1.describe)(colors_1.default.yellow('publish'), function () {
    (0, globals_1.it)('FAIL - invalid manifest', function () { return __awaiter(void 0, void 0, void 0, function () {
        var dir, options, error_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    dir = (0, test_utils_1.getTempFolder)();
                    options = (0, test_utils_1.generateInitOptions)({ type: 'not-valid' });
                    init_1.default.init(programMock, dir, options);
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 3, , 4]);
                    return [4 /*yield*/, publish_1.default.publish(programMock, dir, {
                            privateKey: 'privateKey',
                            rpcUrl: 'rpcUrl',
                        })];
                case 2:
                    _a.sent();
                    return [3 /*break*/, 4];
                case 3:
                    error_1 = _a.sent();
                    node_assert_1.default.match(error_1.message, /manifest contains invalid structure/);
                    return [3 /*break*/, 4];
                case 4: return [2 /*return*/];
            }
        });
    }); }, 20000);
    (0, globals_1.it)('FAIL - invalid privateKey', function () { return __awaiter(void 0, void 0, void 0, function () {
        var dir, options, error_2;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    dir = (0, test_utils_1.getTempFolder)();
                    options = (0, test_utils_1.generateInitOptions)({ type: 'sql' });
                    init_1.default.init(programMock, dir, options);
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 3, , 4]);
                    return [4 /*yield*/, publish_1.default.publish(programMock, dir, {
                            privateKey: 'privateKey',
                            rpcUrl: 'rpcUrl',
                        })];
                case 2:
                    _a.sent();
                    throw new Error('Should not reach here');
                case 3:
                    error_2 = _a.sent();
                    node_assert_1.default.match(error_2.message, /Invalid string. Length must be a multiple of 4/);
                    return [3 /*break*/, 4];
                case 4: return [2 /*return*/];
            }
        });
    }); }, 20000);
    (0, globals_1.describe)(colors_1.default.cyan('SQL'), function () {
        (0, globals_1.it)('OK - SOLE', function () { return __awaiter(void 0, void 0, void 0, function () {
            var dir, options, privkey, r;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        dir = (0, test_utils_1.getTempFolder)();
                        options = (0, test_utils_1.generateInitOptions)({ type: 'sql' });
                        init_1.default.init(programMock, dir, options);
                        return [4 /*yield*/, (0, test_utils_1.generateFoundedUser)()];
                    case 1:
                        privkey = (_a.sent()).privkey;
                        return [4 /*yield*/, publish_1.default.publish(programMock, dir, {
                                privateKey: privkey,
                                rpcUrl: 'http://0.0.0.0:26657',
                            })];
                    case 2:
                        r = _a.sent();
                        node_assert_1.default.ok(r);
                        node_assert_1.default.equal((0, test_utils_1.isUUID)(r.daemonId), true);
                        node_assert_1.default.equal((0, test_utils_1.isUUID)(r.daemonMetadataId), true);
                        return [2 /*return*/];
                }
            });
        }); }, 20000);
        (0, globals_1.it)('OK - SUBSCRIBABLE', function () { return __awaiter(void 0, void 0, void 0, function () {
            var dir, options, privkey, r;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        dir = (0, test_utils_1.getTempFolder)();
                        options = (0, test_utils_1.generateInitOptions)({
                            type: 'sql',
                            subscribable: true,
                        });
                        init_1.default.init(programMock, dir, options);
                        return [4 /*yield*/, (0, test_utils_1.generateFoundedUser)()];
                    case 1:
                        privkey = (_a.sent()).privkey;
                        return [4 /*yield*/, publish_1.default.publish(programMock, dir, {
                                privateKey: privkey,
                                rpcUrl: 'http://0.0.0.0:26657',
                            })];
                    case 2:
                        r = _a.sent();
                        node_assert_1.default.equal((0, test_utils_1.isUUID)(r.daemonMetadataId), true);
                        node_assert_1.default.equal(r.daemonId, undefined);
                        return [2 /*return*/];
                }
            });
        }); }, 20000);
    });
    (0, globals_1.describe)(colors_1.default.cyan('WASM'), function () {
        (0, globals_1.it)('FAIL - no build ', function () { return __awaiter(void 0, void 0, void 0, function () {
            var dir, options, privkey;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        dir = (0, test_utils_1.getTempFolder)();
                        options = (0, test_utils_1.generateInitOptions)({ type: 'wasm' });
                        init_1.default.init(programMock, dir, options);
                        return [4 /*yield*/, (0, test_utils_1.generateFoundedUser)()];
                    case 1:
                        privkey = (_a.sent()).privkey;
                        return [4 /*yield*/, publish_1.default
                                .publish(programMock, dir, {
                                privateKey: privkey,
                                rpcUrl: 'http://0.0.0.0:26657',
                            })
                                .then(function () {
                                throw new Error('Should not reach here');
                            })
                                .catch(function (error) {
                                node_assert_1.default.match(error.message, /Project is not compiled, compile it first, use "mamoru-cli build"/);
                            })];
                    case 2:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        }); }, 20000);
        (0, globals_1.it)('FAIL - SOLE -no enough gas', function () { return __awaiter(void 0, void 0, void 0, function () {
            var dir, options, privkey, r;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        dir = (0, test_utils_1.getTempFolder)();
                        options = (0, test_utils_1.generateInitOptions)({ type: 'wasm' });
                        console.log(colors_1.default.green('dir '), dir);
                        init_1.default.init(programMock, dir, options);
                        return [4 /*yield*/, (0, utils_1.runCommand)('npm install --prefix ' + dir)];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, (0, test_utils_1.generateFoundedUser)()];
                    case 2:
                        privkey = (_a.sent()).privkey;
                        return [4 /*yield*/, build_1.default.build(programMock, dir)];
                    case 3:
                        _a.sent();
                        return [4 /*yield*/, publish_1.default
                                .publish(programMock, dir, {
                                privateKey: privkey,
                                rpcUrl: 'http://0.0.0.0:26657',
                                gas: (500000).toString(),
                            })
                                .then(function () {
                                throw new Error('An error should have been thrown');
                            })
                                .catch(function (error) {
                                node_assert_1.default.match(error.message, /Error sending "MsgCreateDaemonMetadata"/);
                                node_assert_1.default.match(error.message, /out of gas/);
                            })];
                    case 4:
                        r = _a.sent();
                        return [2 /*return*/];
                }
            });
        }); }, 20000);
        (0, globals_1.it)('OK - SOLE', function () { return __awaiter(void 0, void 0, void 0, function () {
            var dir, options, privkey, r;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        dir = (0, test_utils_1.getTempFolder)();
                        options = (0, test_utils_1.generateInitOptions)({ type: 'wasm' });
                        console.log(colors_1.default.green('dir '), dir);
                        init_1.default.init(programMock, dir, options);
                        return [4 /*yield*/, (0, utils_1.runCommand)('npm install --prefix ' + dir)];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, (0, test_utils_1.generateFoundedUser)()];
                    case 2:
                        privkey = (_a.sent()).privkey;
                        return [4 /*yield*/, build_1.default.build(programMock, dir)];
                    case 3:
                        _a.sent();
                        return [4 /*yield*/, publish_1.default.publish(programMock, dir, {
                                privateKey: privkey,
                                rpcUrl: 'http://0.0.0.0:26657',
                                gas: (1000 * 1000 * 100).toString(),
                            })];
                    case 4:
                        r = _a.sent();
                        node_assert_1.default.ok(r);
                        node_assert_1.default.equal((0, test_utils_1.isUUID)(r.daemonId), true);
                        node_assert_1.default.equal((0, test_utils_1.isUUID)(r.daemonMetadataId), true);
                        return [2 /*return*/];
                }
            });
        }); }, 20000);
    });
});
//# sourceMappingURL=publish.test.js.map