import { Manifest } from '../types';
import { DirectSecp256k1Wallet } from '@cosmjs/proto-signing';
import { Logger } from './console';
import { MsgRegisterDaemon } from '@mamoru-ai/validation-chain-ts-client/dist/validationchain.validationchain/module';
import { DaemonMetadataContentQuery } from '@mamoru-ai/validation-chain-ts-client/dist/validationchain.validationchain/types/validationchain/validationchain/daemon_metadata_utils';
import { MsgCreateDaemonMetadata, MsgCreateDaemonMetadataResponse, MsgRegisterDaemonResponse } from '@mamoru-ai/validation-chain-ts-client/dist/validationchain.validationchain/types/validationchain/validationchain/tx';
type TxMsgData = {
    msgResponses: AnyMsg[];
};
type AnyMsg = {
    typeUrl: string;
    value: Uint8Array;
};
export type Msgs = MsgRegisterDaemon | MsgCreateDaemonMetadata | TxMsgData | AnyMsg;
export type ValidationChainMsgs = MsgRegisterDaemon | MsgCreateDaemonMetadata | MsgCreateDaemonMetadataResponse | MsgRegisterDaemonResponse;
declare class ValidationChainService {
    private readonly url;
    private readonly privateKey;
    private readonly logger;
    /**
     * ts-client types are broken, so using any for now
     */
    client: any;
    wallet: DirectSecp256k1Wallet;
    constructor(url: string, privateKey: string, logger: Logger);
    getWallet(): Promise<DirectSecp256k1Wallet>;
    private getClient;
    private getTxClient;
    private getAddress;
    registerDaemonMetadata(manifest: Manifest, queries: DaemonMetadataContentQuery[], wasmModule?: string, gas?: string): Promise<MsgCreateDaemonMetadataResponse>;
    private getDecoder;
    private decodeProtobuf;
    private decodeTxMessages;
    registerDaemon(manifest: Manifest, daemonMetadataId: string): Promise<MsgRegisterDaemonResponse>;
    private formatError;
    private throwOnError;
    /**
     * Utility function that can be used for debug messages from validation-chain protobuf API.
     * Uncomment if you need to debug messages.
     */
    private inspectMsgData;
}
export default ValidationChainService;
//# sourceMappingURL=validation-chain.d.ts.map