"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var validation_chain_ts_client_1 = require("@mamoru-ai/validation-chain-ts-client");
var proto_signing_1 = require("@cosmjs/proto-signing");
var encoding_1 = require("@cosmjs/encoding");
var protobufjs_1 = __importDefault(require("protobufjs"));
var ValidationChainService = /** @class */ (function () {
    function ValidationChainService(url, privateKey, logger) {
        this.url = url;
        this.privateKey = privateKey;
        this.logger = logger;
    }
    ValidationChainService.prototype.getWallet = function () {
        return __awaiter(this, void 0, void 0, function () {
            var key, wallet;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (this.wallet)
                            return [2 /*return*/, this.wallet];
                        key = (0, encoding_1.fromBase64)(this.privateKey);
                        return [4 /*yield*/, proto_signing_1.DirectSecp256k1Wallet.fromKey(key)];
                    case 1:
                        wallet = _a.sent();
                        this.wallet = wallet;
                        return [2 /*return*/, wallet];
                }
            });
        });
    };
    ValidationChainService.prototype.getClient = function () {
        return __awaiter(this, void 0, void 0, function () {
            var wallet;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (this.client)
                            return [2 /*return*/, this.client];
                        return [4 /*yield*/, this.getWallet()];
                    case 1:
                        wallet = _a.sent();
                        this.client = new validation_chain_ts_client_1.Client({
                            apiURL: 'http://0.0.0.0:1317',
                            rpcURL: this.url || 'http://0.0.0.0:26657',
                        }, wallet);
                        return [2 /*return*/, this.client];
                }
            });
        });
    };
    ValidationChainService.prototype.getTxClient = function () {
        return __awaiter(this, void 0, void 0, function () {
            var client;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.getClient()];
                    case 1:
                        client = _a.sent();
                        return [2 /*return*/, client.ValidationchainValidationchain.tx];
                }
            });
        });
    };
    ValidationChainService.prototype.getAddress = function () {
        return __awaiter(this, void 0, void 0, function () {
            var wallet, accounts;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.getWallet()];
                    case 1:
                        wallet = _a.sent();
                        return [4 /*yield*/, wallet.getAccounts()];
                    case 2:
                        accounts = _a.sent();
                        return [2 /*return*/, accounts[0].address];
                }
            });
        });
    };
    ValidationChainService.prototype.registerDaemonMetadata = function (manifest, queries, wasmModule, gas) {
        return __awaiter(this, void 0, void 0, function () {
            var txClient, address, payload, message, r, data, decodeTxMessages, msg;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.logger.verbose('Registering daemon metadata');
                        return [4 /*yield*/, this.getTxClient()];
                    case 1:
                        txClient = _a.sent();
                        return [4 /*yield*/, this.getAddress()];
                    case 2:
                        address = _a.sent();
                        payload = {
                            logoUrl: manifest.logoUrl,
                            metadataType: getSubcribableType(manifest),
                            title: manifest.name,
                            description: manifest.description,
                            tags: manifest.tags,
                            supportedChains: [{ chainType: manifest.chain }],
                            parameters: manifest.parameters,
                            content: getDaemonContent(manifest, queries, wasmModule),
                        };
                        message = {
                            creator: address,
                            daemonMetadata: payload,
                        };
                        this.logger.verbose('message', message);
                        return [4 /*yield*/, txClient.sendMsgCreateDaemonMetadata({
                                value: message,
                                fee: {
                                    amount: [],
                                    gas: gas || '200000',
                                },
                            })];
                    case 3:
                        r = _a.sent();
                        this.throwOnError('MsgCreateDaemonMetadata', r);
                        console.log(r);
                        if (r.code) {
                            throw new Error();
                        }
                        data = r.data;
                        decodeTxMessages = this.decodeTxMessages(data);
                        msg = decodeTxMessages[0];
                        return [2 /*return*/, msg];
                }
            });
        });
    };
    ValidationChainService.prototype.getDecoder = function (name) {
        if (name === void 0) { name = 'TxMsgData'; }
        var parsedName = name.replace('/validationchain.validationchain.', '');
        /**
         * @TODO: instead of hardcode the schema, we should use the generated one from the client.
         * load from client that is placed in "@mamoru-ai/validation-chain-ts-client/proto"
         */
        var root = protobufjs_1.default.parse("\n        syntax = \"proto3\";\n        message Any {\n            string type_url = 1;\n            bytes value = 2;\n        }\n\n        message MsgCreateDaemonMetadataResponse {\n            string daemonMetadataId = 1;\n        }\n\n        message MsgRegisterDaemonResponse {\n            string daemonId = 1;\n        }\n\n        message TxMsgData {\n            repeated Any msg_responses = 2;\n        }\n        ").root;
        return root.lookupType(".".concat(parsedName));
    };
    ValidationChainService.prototype.decodeProtobuf = function (name, data) {
        var result = this.getDecoder(name).decode(data);
        return result;
    };
    ValidationChainService.prototype.decodeTxMessages = function (data) {
        var _this = this;
        var result = this.getDecoder().decode(data);
        return result.msgResponses.map(function (msg) {
            return _this.decodeProtobuf(msg.typeUrl, msg.value);
        });
    };
    ValidationChainService.prototype.registerDaemon = function (manifest, daemonMetadataId) {
        return __awaiter(this, void 0, void 0, function () {
            var txClient, address, payload, value, r, data, decodeTxMessages;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.logger.verbose('Registering daemon');
                        return [4 /*yield*/, this.getTxClient()];
                    case 1:
                        txClient = _a.sent();
                        return [4 /*yield*/, this.getAddress()];
                    case 2:
                        address = _a.sent();
                        payload = {
                            chain: { chainType: manifest.chain },
                            daemonMetadataId: daemonMetadataId,
                            // @TODO: add parameters
                            parameters: [],
                            // @TODO: add relay
                            relay: {
                                type: 0,
                                address: '',
                                call: '',
                            },
                        };
                        value = {
                            creator: address,
                            daemon: payload,
                        };
                        this.logger.verbose('Payload', payload);
                        return [4 /*yield*/, txClient.sendMsgRegisterDaemon({
                                value: value,
                            })];
                    case 3:
                        r = _a.sent();
                        this.throwOnError('MsgRegisterDaemon', r);
                        data = r.data;
                        decodeTxMessages = this.decodeTxMessages(data);
                        return [2 /*return*/, decodeTxMessages[0]];
                }
            });
        });
    };
    ValidationChainService.prototype.formatError = function (msgType, error) {
        var code = error.code, rawLog = error.rawLog;
        return "Error sending \"".concat(msgType, "\" code: \"").concat(code, "\", log: \"").concat(rawLog, "\" hash: \"").concat(error.transactionHash, "\"");
    };
    ValidationChainService.prototype.throwOnError = function (MsgType, response) {
        if (response.code) {
            throw new Error(this.formatError(MsgType, response));
        }
        return response;
    };
    /**
     * Utility function that can be used for debug messages from validation-chain protobuf API.
     * Uncomment if you need to debug messages.
     */
    ValidationChainService.prototype.inspectMsgData = function (data) {
        // console.log('----------------------------')
        // const buffer = Buffer.from(data)
        // const d = getData(buffer)
        // const schema = getProto(buffer)
        // console.log(schema)
        // console.log(JSON.stringify(d, null, 2), false, 100, true)
        // inspect(getData(Buffer.from()), false, 100, true)
        // console.log('----------------------------')
    };
    return ValidationChainService;
}());
exports.default = ValidationChainService;
function getSubcribableType(manifest) {
    if (manifest.subscribable) {
        return 2;
    }
    return 1;
}
function getDaemonContent(manifest, queries, wasmModule) {
    if (manifest.type === 'wasm') {
        return {
            type: 1,
            wasmModule: wasmModule,
            query: [],
        };
    }
    return {
        type: 0,
        query: queries,
        wasmModule: '',
    };
}
function randomNumericChar() {
    var numbersWithoutZero = '123456789';
    return numbersWithoutZero[Math.floor(Math.random() * numbersWithoutZero.length)];
}
function randomId() {
    return parseInt(Array.from({ length: 12 })
        .map(function () { return randomNumericChar(); })
        .join(''), 10);
}
function createJsonRpcRequest(method, params) {
    var paramsCopy = params ? __assign({}, params) : {};
    return {
        jsonrpc: '2.0',
        id: randomId(),
        method: method,
        params: paramsCopy,
    };
}
//# sourceMappingURL=validation-chain.js.map